/*
 * sytick.c
 *
 *  Created on: Apr 6, 2012
 *      Author: Philip
 */
#include "stm32f4_discovery.h"

static __IO uint32_t time = 0;


uint8_t time_init() {
	// 1 ticks per ms
  if (SysTick_Config(SystemCoreClock / 1000)) {
    return 0;
  }
  return 1;
}

uint32_t time_getMS() {
	return time;
}

void time_wait(uint32_t delayMs) {
	uint32_t end = time_getMS() + delayMs;
	while(end > time_getMS()) {
	}
}

void time_waitUs(uint16_t delay) {
	// determined by trial and error...
	uint8_t temp;
	while (delay) {
		temp = 12;
		while(temp) {
			temp--;
		}
		delay--;
	}
}

void time_waitNs(uint16_t delay) {
	// determined by trial and error...
	delay = delay >> 6;
	while (delay) {
		delay--;
	}
}




void time_interrupt() {
	time++;
}
